# -*- coding: utf-8 -*-
# Algorithmus-von-Prim.py
# verwendet die Abschnitte aus gallenbacher_dijkstra_iterativ.py
# ersetzt wege durch Kanten
# prioSchlange objektorientiert umgesetzt


class PrioSchlange():
    '''Das Prädikat vor muss übergeben werden.'''
    
    def __init__(self):
        self.kanten=[]

    def gibkanten(self):
        return self.kanten

    ### ===== fuegeEinesEin =====
    # fuegt ein Element in die Prio-Schlange ein
    # benötigt das Praedikat vor
    def fuegeEinesEin(self, eines, vor):
        for i in range(len(self.kanten)):
            if vor(eines, self.kanten[i]):
                self.kanten = self.kanten[:i] + [eines] + self.kanten[i:]
        self.kanten += [eines]

    ### ===== fuegeAlleEin =====
    # fuegt alle uebergebenen Elemente in die Prio-Schlange ein
    # benötigt das Praedikat vor
    def fuegeAlleEin(self, alle, vor):
        for eines in alle:
            self.fuegeEinesEin(eines, vor)

    
    def entferneZyklen(self, enthalteneKnoten):
        '''Entferne alle Zyklen'''
        temp=[]
        for kante in self.kanten:
            if not (kante[0] in enthalteneKnoten):
                temp.append(kante)
            elif not (kante[1] in enthalteneKnoten):
                temp.append(kante)
        self.kanten=temp
        
    def ersteRaus(self):
        temp = self.kanten[0]
        self.kanten=self.kanten[1:]
        return temp


# ----- kuerzer -----
def kuerzer(kante1, kante2):
    '''das ist die zu übergebende Funktion für vor'''
    return  kante1[2] < kante2[2]

def nachfolgeKanten(knoten):
    kanten=[]
    nachfolger=graph[knoten]
    for nach in nachfolger:
        kanten.append([knoten]+nach)
    return kanten

# ----- Der eigentliche Algorithmus -----
# 
def AvPrim(startknoten):
    baum=[]
    enthalteneKnoten=[startknoten]
    neuerKnoten=startknoten
    prioSchlange=PrioSchlange()
    while len(enthalteneKnoten)<len(graph):
        prioSchlange.fuegeAlleEin(nachfolgeKanten(neuerKnoten),
                                  kuerzer)
        # Entferne alle Zyklen:
        prioSchlange.entferneZyklen(enthalteneKnoten)
        # Die erste Kante setzt den Baum minimal fort
        erste=prioSchlange.ersteRaus()
        baum.append(erste)
        if erste[0] in enthalteneKnoten:
            enthalteneKnoten.append(erste[1])
            neuerKnoten=erste[1]
        else:
            enthalteneKnoten.append(erste[0])
            neuerKnoten=erste[0]
    return baum


### Laenge bestimmen:
def laengeKanten(kanten):
    if kanten==[]: return 0
    return kanten[0][2]+laengeKanten(kanten[1:])


### ----- Ausgabe -----
def Ausgabe(startKnoten):
    baum=AvPrim(startKnoten)
    print( baum )
    print( 'Gesamtlaenge aller Kanten:', laengeKanten(baum))
### ===== Testaufruf =====
from gallenbacher_graph import gallenbacherGraph as graph
Ausgabe('I')


### Graph von Turau: (mustergraph --> graph)
graph={ 1: [[2,4],[6,10], [7,5]],
        2: [[1,4],[3,7],[7,2]],
        3: [[2,7],[4,12],[7,1]],
        4: [[3,12],[5,4]],
        5: [[4,4],[6,3],[7,8]],
        6: [[1,10],[5,3],[7,4],[7,4]],
        7: [[1,5],[2,2],[6,4],[3,1],[5,8],[6,4]]}

Ausgabe(1)
